
local KMPvars = {
	{disp = "Frantic Items", var = "kartfrantic"},
	{disp = "Bumpspark", var = "kmp_bumpspark"},
	{disp = "Hardsneaker", var = "kmp_hardsneakers"},
	{disp = "Long Flashtics", var = "kmp_extendflashtics"},
	{disp = "1.0.4 Spinout", var = "kmp_slowspinout"},
	{disp = "Dropped Item Fuse", var = "kmp_floatingitemfuse"},
	{disp = "Item Limiter", var = "kmp_itemlimiter"},
	{disp = "Orbital Limiter", var = "kmp_orbitlimit"},
	{disp = "Extended Hyudoro", var = "kmp_hyudoro"},
	{disp = "Orbinaut Fuse", var = "kmp_orbinautfuse"},
	{disp = "No Midair Squish", var = "kmp_growthbump"},
	{disp = "Haste", var = "kmp_haste"},
	{disp = "Respawn Anywhere", var = "kmp_respawnpoints"},
	{disp = "Shrink Cleanse", var = "kmp_shrinkcleanse"},
	{disp = "Shrink Pity", var = "kmp_shrinkduration"},
	{disp = "Battle Accel", var = "kmp_battleaccel"},
}


local function clan(p, ...)
	if not ... then
		p.HMclan = nil
		CONS_Printf(p, "Clan tag removed.")
	else
		local fug = table.concat({...}, " ")
		local lowerfug = fug:lower()
		if fug:len() > 10 then
			CONS_Printf(p, "Too long.")
			return
		elseif lowerfug:match("staff") or lowerfug:match("admin") or lowerfug:match("krew") or lowerfug:match("mod") or lowerfug:match("~") or lowerfug:match("@") then
			CONS_Printf(p, "Nice Try!")
			return
		else
			p.HMclan = fug
			if lowerfug:match("gang") then
				CONS_Printf(p, 'Tag set to "'..fug..'". :V')
			else
				CONS_Printf(p, 'Tag set to "'..fug..'".')	
			end
		end
	end
end
COM_AddCommand("clan", clan)

-- I KNOW THERE'S A FUCKIN FUNCTION IN SOURCE FOR THIS
-- WHY IS IT NOT EXPOSED TO LUA
-- LAAAAAAAAAAAAAAAAAAAAAAT
local function wrapString(str, width, v, flags, font)
	local words = {}
	for word in str:gmatch("%S+") do table.insert(words, word) end
	local retlines = {}
	local buffer = words[1]
	for i = 2, #words
		local fug = buffer.." "..words[i]
		if v.stringWidth(fug, flags, font) > width then
			table.insert(retlines, buffer)
			buffer = words[i]
		else
			buffer = fug
		end
	end
	table.insert(retlines, buffer)
	return retlines
end

local function doEscapeCode(str)
	for _, v in pairs(hm_escape)
		str = str:gsub(v.a, v.b)
	end
	return str
end

local function buildTimeString(x)
	if x == nil or x == 99999999 then return "N/A" end
	return ""..string.format("%02d", G_TicsToMinutes(x)).."' "..string.format("%02d", G_TicsToSeconds(x))..'" '..string.format("%02d", G_TicsToCentiseconds(x))
end

addHook("ThinkFrame", function()
end)


local function _hudDrawMsgLine(v, msg, fx, fy, off)
	v.drawString(fx, fy+(off*5), msg, V_ALLOWLOWERCASE, "small")
end


-- hacked-up TSR scoreboard, WHEEEEEEEEEEEEEEE
-- thanks snu
hud.add(function(v, p, c)
	hud.disable("rankings")
	v.fadeScreen(0xFF00, 16)	-- fade the screen

	-- store highlight colour here for use in the hud throughout
	local hilicol
	if (CV_FindVar("menuhighlight").value)
		hilicol = CV_FindVar("menuhighlight").value
	elseif (modeattacking)
		hilicol = V_ORANGEMAP
	else
		hilicol = ((gametype == GT_RACE) and V_SKYMAP or V_REDMAP)
	end
	
	if false and consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
		local reverseplayers = {}
		for k,v in players.iterate do
		   reverseplayers[v] = k
		end
	end
	
	-- draw lap count and game speed
	if not G_BattleGametype() then
		v.drawString(64, 8, "LAP COUNT", 0, "center")
		v.drawString(64, 16, (numlaps), hilicol, "center")
		v.drawString(256, 8, "GAME SPEED", 0, "center")
		v.drawString(256, 16, CV_FindVar("kartspeed").string, hilicol, "center")
	end
	
	-- draw line between gametypeinfo and teams
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320 (based on what?)
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical
	
	v.drawString(4, 188, hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).." - "..mapheaderinfo[gamemap].subttl, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

	-- draw right pane
	local fy = 28
	local fx = 163
	local off = 0 -- right pane line offset OH GOD this code is everywhere
	local motd = CV_FindVar("hm_motd")
	if motd and motd.value then
		v.drawString(fx, fy, doEscapeCode(CV_FindVar("hm_motd_name").string), V_ALLOWLOWERCASE, "thin")
		v.drawString(fx, fy+10, "\134Contact: "..doEscapeCode(CV_FindVar("hm_motd_contact").string), V_ALLOWLOWERCASE, "small")
		off = $ + 4
	end
	
	local restat = CV_FindVar("hm_restat")
	
	_hudDrawMsgLine(v, "Memo - server's & page address: ƒstrashbot.fr", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "---", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "„Chat€ votes commands:", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!elim on/off€ - elimination on/off", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!juicebox on/off€ - juicebox on/off", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!friend on/off€ - friendmod on/off", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!acro on/off€ - acrobatics on/off", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!cruel on/off€ - just don't", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!drift€ - driftgauge toggle", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!tags€ - nameplates toggle", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!speed hard/normal€ - server speed change", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!restartlevel€ - restart the current level", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!resetscores€ - reset players scores", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!kick ˆplayer€ - kick s.o.", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!rtv€ - change map", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!first to ˆX€ - start a FT X (X= number)", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!race/battle€ - gametype rotation", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "  „!race/battle only/!€ - gametype switch", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "---", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "Now on KartHub France's Discord : ", fx, fy, off)
	off= $+1
	_hudDrawMsgLine(v, "   ƒhttps://strashbot.fr/invit", fx, fy, off)
	
	if drew then off = ($ / 2) + ($ % 2) + 1 end

	-- draw players
	local tsr_rankings = {}
	for p in players.iterate
		if (p and p.valid) and not p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	table.sort(tsr_rankings, function(a, b) return a.kartstuff[k_position] < b.kartstuff[k_position] end)
	for p in players.iterate
		if p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	if not #tsr_rankings then return end

	for i = 1, #tsr_rankings
		local p = tsr_rankings[i]
		local hy = 28 + (i-1)*10
		local specflag = (p.spectator or p.rs_check2) and V_50TRANS or 0

		-- player ping:
		if (p ~= server)  -- the server doesnt have a ping
		and (netgame)	-- we obviously need to be in a netgame too
			-- my hopes with writing this code is that it's so bad that I'm never allowed to write ping related code ever again
			local ping = p.ping	-- thanks 1.3
			-- get the ping patch we'll use
			local ping_gfxnum, ping_values = 1, {76, 137, 256, 500}
			for i = 1, #ping_values
				if (ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			-- sadly p.cmd.latency caps at 11 so it cant go any higher without hacks so huge that I cant be assed
			v.draw(3, hy, v.cachePatch("HMPING"..ping_gfxnum), specflag)
		end
		-- rank:
		if not p.spectator then
			v.drawString(29, hy+1, p.kartstuff[k_position], 0, "right")
		end
		-- draw skin icon
		if (p.mo and p.mo.valid) then
			local pp = skins[p.mo.skin].facerank
			local cmap = v.getColormap(p.mo.skin, p.mo.color)
			local dieflag = 0
			if p.mo.colorized then cmap = v.getColormap(TC_RAINBOW, p.mo.color) end
			if G_BattleGametype() and p.kartstuff[k_bumper] <= 0 then
				cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
				dieflag = V_50TRANS
			end
			v.drawScaled(30<<FRACBITS, (hy+1)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), specflag|dieflag, cmap)
		end
		-- name: c[p.tsr_team]..p.name
		local c = 0
		local index = p.tsr_team or 6
		local fugname = ""
		if p.HMclan then fugname = $.."\140"..p.HMclan.." \128" end
		--if p.HMclan then fugname = $..hm_color[p.skincolor]..p.HMclan.." | \128" end
		if p == consoleplayer then fugname = $..hm_color[p.skincolor] end
		if p.name == nil then
			fugname = $.."Glitched player :?"
		else
			fugname = $..p.name
		end
		while v.stringWidth(fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin") > 100
			fugname = $:sub(1, -2)
		end
		if consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
			fugname = $.." \x86["..#p.."]"
		end
		v.drawString(39, hy, fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin")
		if (p.mo and p.mo.valid) then
			local restatflag = p.HMRs and V_YELLOWMAP or 0
			v.drawString(29, hy, p.kartspeed, restatflag, "small")
			v.drawString(39, hy+6, p.kartweight, restatflag, "small-right")
		end
		-- points:
		local points = ""
		if p.spectator then
			if p.pflags & PF_WANTSTOJOIN then
				points = "WAIT"
			else
				points = "SPEC"
			end
		elseif p.rs_check2 then
			points = "RAGE"
		elseif p.pflags & PF_TIMEOVER then
			points = "NO CONTEST."
		elseif G_BattleGametype() then
			points = p.marescore
		elseif not p.exiting then
			points = "LAP "..(p.laps+1)
		else
			points = buildTimeString(p.realtime)
		end
		v.drawString(157, hy, points, (p.exiting and hilicol or 0)|V_6WIDTHSPACE|specflag, "thin-right")
	end
end, "scores")